Subject: Re: [RFC PATCH v0 1/2] net: bridge: propagate FDB table into hardware

From: John Fastabend <[email-masked]>
Date: Thu, 09 Feb 2012 09:52:55 -0800

On 2/9/2012 9:40 AM, Stephen Hemminger wrote:
> On Thu, 09 Feb 2012 09:36:47 -0800
> John Fastabend <[email-masked]> wrote:
> 
>> But the device features makes it easy for user space to learn that the device
>> supports this sort of offload. Now if all SR-IOV devices support this then it
>> doesn't matter but I thought there were SR-IOV devices that didn't do any
>> switching? I'll dig through the SR-IOV drivers to check there are not too
>> many of them.
> 
> If user space needs to know then the OS is not designed properly.
> The purpose of the network device is to abstract all those details, and more and more
> of them are bleeding through. This makes writing management applications harder and makes
> things dependent on features that may or may not be present. The best design is when
> the change is invisible.
> 

Agreed.

>> By netlink_notifier do you mean adding a notifier_block and using atomic_notifier_call_chain()
>> probably in rtnl_notify()? Then drivers could register with the notifier chain with
>> atomic_notifier_chain_register() and receive the events correctly. Or did I miss
>> some notifier chain that already exists?
> 
> Yes. that is what I mean. The callbacks you need may or may not already be present.

OK thanks I'll put together an update here shortly.